package org.enhydra.barracuda.contrib.dbroggisch.examples.pages;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;
import java.util.Set;
import java.io.IOException;
import org.enhydra.barracuda.core.event.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.contrib.dbroggisch.page.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.events.*;
import org.enhydra.barracuda.contrib.dbroggisch.examples.forms.*;
import org.enhydra.barracuda.contrib.dbroggisch.display.*;
import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.w3c.dom.Document;
import javax.servlet.ServletException;
import org.enhydra.barracuda.contrib.dbroggisch.examples.xmlc.*;
import org.enhydra.xml.xmlc.XMLCStdFactory;

public class FileUploadPage extends ExampleBasePage {

	List _names;

	public void setNames(List names) {
		_names = names;
	}

	public void render(BComponent root, ViewContext vec, Document pDoc) 
		throws EventException, ServletException, IOException
    {
		super.render(root, vec, pDoc);
		FileUploadHTML doc = (FileUploadHTML)pDoc;
		BList fList = new BList();
		fList.setView(new DefaultView(doc.getElementFileNames()));
		DefaultListModel dlm = new DefaultListModel();
		dlm.addAll(_names);
		fList.setModel(dlm);
		root.addChild(fList);
    }

	public Document getDocument() {
		return new XMLCStdFactory(null, null).create(FileUploadHTML.class);
	}

}
