package org.enhydra.barracuda.tutorials.comp;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.w3c.dom.*;
import org.enhydra.xml.xmlc.*;

import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.tutorials.xmlc.*;

/**
 * Here's an example of HelloWorld using the BTemplate
 * component
 */
public class HelloWorld2Footer {

    public static Node getNode(ViewContext vc) {
        return getNode(vc.getElementFactory().getDocument());
    }
    
    public static Node getNode(Document doc) {
        XMLCFactory xmlcFactory = new XMLCStdFactory(doc.getClass().getClassLoader(), new StreamXMLCLogger());
        Node footerNode = xmlcFactory.create(HelloWorld2_footerHTML.class).getElementById("Footer");
        return doc.importNode(footerNode, true);
    }
}
