package org.enhydra.barracuda.contrib.dbroggisch.display.filters;

import java.util.*;
import org.enhydra.barracuda.contrib.dbroggisch.display.filters.dtd.*;

public class ConstantFilter implements Filter {

		private Object constant;

		public ConstantFilter(Object c) {
				constant = c;
		}

		public ConstantFilter() {
				this(null);
		}
		
		/**
     *
     * @param obj will be ignored
     * @return the Object specified in the constructor
     */
		public Object filter(Object obj, FilterContext context)
 				throws FilterException
		{
				return constant;
		}


		public Filter configure(Object obj)
				throws FilterException 
		{
				Constant con = (Constant)obj;
				constant = con.getValue();
				return this;
		}
}
