package org.enhydra.barracuda.contrib.dbroggisch.examples.forms;

import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.enhydra.barracuda.core.forms.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.forms.validators.*;

public class ChildFormMap extends RepopulationFormMap {

	public final static String MODEL_NAME = "ChildModel";
	public final static String CHILD_NAME = "CHILD_NAME";

	public ChildFormMap() {
		setName(MODEL_NAME);
		defineElement(new DefaultFormElement(
										   CHILD_NAME,
										   FormType.STRING,
										   null,
										   new NotNullValidator(),
										   false));


	}

}
