package org.enhydra.barracuda.contrib.dbroggisch.examples.forms;

import org.enhydra.barracuda.contrib.dbroggisch.repopulation.*;
import org.enhydra.barracuda.core.forms.*;
import org.enhydra.barracuda.core.comp.*;
import org.enhydra.barracuda.core.forms.validators.*;

public class ParentFormMap extends RepopulationFormMap {

	public final static String MODEL_NAME = "ParentModel";
	public final static String PARENT_NAME = "PARENT_NAME";
	public final static String CHILD_COUNT = "CHILD_COUNT";

	public ParentFormMap() {
		setName(MODEL_NAME);
		defineElement(new DefaultFormElement(
										   PARENT_NAME,
										   FormType.STRING,
										   null,
										   new NotNullValidator(),
										   false));

		defineElement(new DefaultFormElement(
										   CHILD_COUNT,
										   FormType.INTEGER,
										   null,
										   null,
										   false));

	}
}
